/* 
 * Copyright (c) 2003 Greg Taleck <taleck@oz.net>
 *
 * $Id: hexdump.c,v 1.2 2003/10/01 18:58:15 taleck Exp $
 */
#include <sys/types.h>
#include <stdio.h>
#include <ctype.h>

void
hexdump(const u_char* ptr, int len)
{
    int i,j,k;

    for (i = 0; i < len; i+=0x10) {
        printf("0x%04x   ", i);
        j = i;
        for (j = i; j < len && j < i + 0x10; j++) {
          printf("%02x", ptr[j] & 0xff);
          if ((j % 2) == 1) printf(" ");
        }

        for (k = 0; k < (i-j+0x10)/2; k++)
            printf(" ");

        while (j < i + 0x10) {
            printf("  ");
            j++;
        }

        printf("    ");

        j = i;
        for (j = i; j < len && j < i + 0x10; j++) {
            if (isprint(ptr[j]))
                printf("%c", ptr[j] & 0xff);
            else
                printf(".");
        }
        printf("\n");
    }
}
